package htLuokat;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 * @author leevi
 * @version 2 Mar 2022
 *
 */
public class Huone {
    private int id;  
    private String nimi = ""; 
    private static int seuraavaNro = 1;

    /**
     * @param nimi huoneen nimi
     */
    public Huone(String nimi) {
        this.nimi = nimi;
    }
    
    /**
     * rekisteröi uuden huoneen
     * @return huoneen id numero
     */
    public int rekisteroi() {
        this.id = seuraavaNro;
        seuraavaNro++;
        return this.id;
    }
    
    /**
     * @return palauttaa id:n
     */
    public int getId() {
        return id;
    }
    
    /**
     * @return palauttaa nimen
     */
    public String getNimi() {
        return nimi;
    }
    
    
    /**
     * tulostaa tiedot
     * @param out tietovirta 
     */
    public void tulosta(PrintStream out) {
        out.println(nimi + ", ID: " + id);
    }
    
    /**
     * tulostaa huoneen tiedot
     * @param os tietovirta
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }
    
    /**
     * @param args ei kaytossa 
     */
    public static void main(String [] args) {
        
        Huone keittio = new Huone("keittio");
        keittio.rekisteroi();
        keittio.tulosta(System.out);
        
        Huone vessa = new Huone("vessa");
        vessa.rekisteroi();
        vessa.tulosta(System.out);
        
        
    }
    
}
