package htLuokat;

/**
 * @author leevi
 * @version 2 Mar 2022
 *
 */
public class Huoneet {

    private static final int  MAX_Huoneet = 10; 
    private Huone[] huoneet;
    private int lkm = 0; 

    /**
     * @param args ei kaytossa 
     */
    public static void main(String[]args)  {
        Huoneet huoneet = new Huoneet();
        
        Huone keittio = new Huone("keittio");
        Huone vessa = new Huone("vessa");
        keittio.rekisteroi();
        vessa.rekisteroi();
        try {
            
            huoneet.lisaa(keittio);
            huoneet.lisaa(vessa);
            
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
        keittio.tulosta(System.out);
        

        vessa.tulosta(System.out);
        
    }
    
    /**
     * @param huone huone 
     * @throws SailoException heitetään jos liikaa huoneita
     */
    public void lisaa(Huone huone) throws SailoException {
        if(lkm >= huoneet.length) throw new SailoException("Liikaa huoneita!");
        huoneet[lkm] = huone;
        lkm++;
    }
    
    /**
     * palauttaa viitteen huoneeseen
     * @param i mones huone halutaan
     * @return viite huoneeseen
     * @throws IndexOutOfBoundsException jos i ei sallitulla alueella
     */
    public Huone anna(int i) throws IndexOutOfBoundsException {
        if(i < 0 || lkm <= i)
            throw new IndexOutOfBoundsException("Laiton indeksi" + i);
        return huoneet[i];
    }
    
    /**
     * parametriton muodostaja
     */
    public Huoneet() {
        huoneet = new Huone[MAX_Huoneet];
    }
    
    /**
     * @return huoneiden lkm
     */
    public int gethuoneetlkm() {
        return lkm;
    }
    
    /**
     * @param i huoneen indeksi
     * @return huone
     */
    public Huone gethuone(int i ) {
        return huoneet[i];
    }
}
