package htLuokat;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 * @author leevi
 * @version 2 Mar 2022
 *
 */
public class Tehtava {
    private int id;  
    private String nimi = ""; 
    private static int seuraavaNro = 1;

    /**
     * @param nimi tehtavan nimi
     */
    public Tehtava(String nimi) {
        this.nimi = nimi;
    }
    
    /**
     * rekisteröi uuden tehtavan 
     * @return tehtavan id numero
     */
    public int rekisteroi() {
        this.id = seuraavaNro;
        seuraavaNro++;
        return this.id;
    }
    
    /**
     * @return palauttaa id:n
     */
    public int getId() {
        return id;
    }
    
    /**
     * @return palauttaa nimen
     */
    public String getNimi() {
        return nimi;
    }
    
    
    /**
     * tulostaa käyttäjän tiedot
     * @param out tietovirta 
     */
    public void tulosta(PrintStream out) {
        out.println(nimi + ", ID: " + id);
    }
    
    /**
     * tulostaa huoneen tiedot
     * @param os tietovirta
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }
    
    /**
     * @param args ei kaytossa 
     */
    public static void main(String [] args) {
        
        Tehtava imurointi = new Tehtava("Imurointi");
        imurointi.rekisteroi();
        imurointi.tulosta(System.out);
        
        Tehtava luuttuaminen = new Tehtava("Luuttuaminen");
        luuttuaminen.rekisteroi();
        luuttuaminen.tulosta(System.out);
        
        
    }

    /**
     * @return nimi
     */
    public String getTehtavaNimi() {
        
        return this.nimi;
    }
}
