package htLuokat;

import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author jaakk
 * @version 2 Mar 2022
 *
 */
public class TehtavaLoki {
    
    private String kellonaika;
    private Kayttaja kayttaja;
    private Huone huone;
    private Tehtava tehtava;
    
    
    
    /**
     * @return aika
     */
    public static String getTime() {
        Date aika = new Date(System.currentTimeMillis());
        SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd 'klo' HH:mm:ss");
        return formatter.format(aika);
    }
    
    /**
     * @param h huone
     */
    public void lisaaHuone(Huone h) {
        huone = h;
    }
    
    /**
     * luodaan yksittäinen merkintä
     */
    public TehtavaLoki() {
        kellonaika = getTime();
        kayttaja = getKayttaja();
        huone = getHuone();
        tehtava = getTehtava();
    }

    /**
     * hakee tiedon valitusta käyttäjästä
     * @return valittu käyttäjä
     */
    public Kayttaja getKayttaja() {
        return kayttaja;
    }
    
    /**
     * hakee huoneen
     * @return valittu huone
     */
    public Huone getHuone() {
        return huone;
    }
    
    /**
     * hakee tehtävän
     * @return valittu tehtävä
     */
    public Tehtava getTehtava() {
        return tehtava;
    }
    
    /**
     * @param out tietovirta
     */
    public void tulosta(PrintStream out) {
        out.println(kellonaika + " " + kayttaja.getNimi()+ " " + huone.getNimi() + " " + tehtava.getNimi());
    }
    
    /**
     * @param huone huone
     */
    public void setHuone(String huone) {
       Huone h = new Huone(huone);
       this.huone = h;
    }
    
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        TehtavaLoki suoritus = new TehtavaLoki();
        suoritus.tulosta(System.out);
    }

    /**
     * @param tehtava1 tht
     */
    public void lisaaTehtava(Tehtava tehtava1) {
        this.tehtava = tehtava1;
        
    }

    /**
     * @param kayttaja2 äijä
     */
    public void lisaaKayttaja(Kayttaja kayttaja2) {
        kayttaja = kayttaja2;
        
    }
    
}