package htLuokat;

/**
 * @author leevi
 * @version 2 Mar 2022
 *
 */
public class Tehtavat {
    private static final int  MAX_TEHTAVAT = 15; 
    private Tehtava[] kaikkiTehtavat;
    private int lkm = 0; 
    
    /**
     * @param args ei kaytossa 
     */
    public static void main(String[]args)  {
        Tehtavat tehtavat = new Tehtavat();
        Tehtava imurointi = new Tehtava("Imurointi");
        imurointi.rekisteroi();
        imurointi.tulosta(System.out);
        
        Tehtava luuttuaminen = new Tehtava("Luuttuaminen");
        luuttuaminen.rekisteroi();
        luuttuaminen.tulosta(System.out);
        
        try {
            tehtavat.lisaa(imurointi);
            tehtavat.lisaa(luuttuaminen);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    /**
     * @param tehtava tehtava 
     * @throws SailoException heitetään jos liikaa tehtavia
     */
    public void lisaa(Tehtava tehtava) throws SailoException {
        if(lkm >= kaikkiTehtavat.length) throw new SailoException("Liikaa Tehtavia!");
        kaikkiTehtavat[lkm] = tehtava;
        lkm++;
    }
    
    /**
     * palauttaa viitteen huoneeseen
     * @param i mones huone halutaan
     * @return viite huoneeseen
     * @throws IndexOutOfBoundsException jos i ei sallitulla alueella
     */
    public Tehtava anna(int i) throws IndexOutOfBoundsException {
        if(i < 0 || lkm <= i)
            throw new IndexOutOfBoundsException("Laiton indeksi" + i);
        return kaikkiTehtavat[i];
    }
    
    /**
     * parametriton muodostaja
     */
    public Tehtavat() {
        kaikkiTehtavat = new Tehtava[MAX_TEHTAVAT];
    }
    
    /**
     * @return lkm
     */
    public int getlkm() {
        
        return lkm;
    }
    
    
    /**
     * @param i indeksi
     * @return tehtava
     */
    public Tehtava getTehtava(int i) {
        
        return kaikkiTehtavat[i];
    }
}
