package htScene;

import java.awt.Desktop;
import java.io.IOException;
import java.io.PrintStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import htLuokat.KotityoRekisteri;
import htLuokat.TehtavaLoki;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.TextArea;
import javafx.scene.layout.BorderPane;
import javafx.scene.text.Font;
import javafx.stage.Stage;

/**
 * @author leevi
 * @version 31.1.2022
 *
 */
public class KotityoGUIController implements Initializable {
   //testaa 
    KotityoRekisteri rekisteri = new KotityoRekisteri();
    muokkaaController muokkaa;
    
    /// suoirtuksen lisays
    SuoritusController suoritus;
    
    @FXML private BorderPane poistosivu;
    
    @FXML private ScrollPane panelSuoritus = new ScrollPane();

    @FXML private TextArea tulostusview = new TextArea();
    
    @FXML private Button about;

    @FXML private Button help;
    
    @FXML void handleAbout() {
        Dialogs.showMessageDialog("Kotityöloki" + "\n" + "Tekijät:"+ "\n"+ "Jaakko Jokisalo "
    + "\n" + "Jaakko Juvonen" + "\n" + "Leevi Pohja " + "\n" + "Version 0.3");
        
    }

    @FXML void handleHelp() {
        avustus();
    }
    
    @FXML void avaaLisaa() {
        
        
        try {
        FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("suoritus.fxml"));
        Parent root1 = (Parent) fxmlLoader.load();
        Stage stage = new Stage();
        stage.setScene(new Scene(root1));
        stage.show(); 
        
         suoritus = (SuoritusController)fxmlLoader.getController();
         suoritus.setrekisteri(rekisteri);
         suoritus.alusta();
         suoritus.setTulostus(panelSuoritus, tulostusview);
         

        
         
   
        
    } catch (Exception e) {
        System.err.println(e.getMessage()); 
        } 
    }

    @FXML void avaaMuokkaa() {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkausView.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show(); 
            
            /// test
           muokkaa = (muokkaaController)fxmlLoader.getController();
           muokkaa.setrekisteri(rekisteri);
           
           
        } catch (Exception e) {
            System.err.println(e.getMessage()); 
            } 
        

        
        }
    // Poistoikkunan kontrollit
    @FXML private Button cancelPoista;

    @FXML private Button poistaOk;

    @FXML void handleCancel() {
        ModalController.closeStage(poistosivu);
    }

    @FXML
    void handlePoistaOk() {
        Dialogs.showMessageDialog("Tässä kohtaa poistetaan valittu kohde(ei osata vielä)");
        ModalController.closeStage(poistosivu);
    }



    
    
    /**
     * @return kkk
     */
    public boolean avaa() {
        return true;
    }
    private void avustus() {
        Desktop desktop = Desktop.getDesktop();
        try {
            URI uri = new URI("https://tim.jyu.fi/view/kurssit/tie/ohj2/2022k/ht/pohjalma%22");
            desktop.browse(uri);
        } catch (URISyntaxException e) {
            return;
        } catch (IOException e) {
            return;
        }
    }
    
    @Override
    public void initialize(URL url, ResourceBundle bundle) {
//        alusta();
    }
    
    
    /**
     * @param rekisteri rekisteri
     */
    public void setrekisteri(KotityoRekisteri rekisteri) {
        this.rekisteri = rekisteri;
    }


   
}
