package htScene;

import java.net.URL;
import java.util.ResourceBundle;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import htLuokat.Huone;
import htLuokat.Kayttaja;
import htLuokat.Kayttajat;
import htLuokat.KotityoRekisteri;
import htLuokat.SailoException;
import htLuokat.Tehtava;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleGroup;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;
/**
 * @author jaakk
 * @version 16 Feb 2022
 *
 */
public class muokkaaController  implements Initializable{
    /// test
    KotityoRekisteri rekisteri = new KotityoRekisteri();
    muokkaaNextController huoneTehtava = new muokkaaNextController();
    KayttajaController kikkuna;

 /**
 * 
 */
@FXML private ListChooser<Object> kohdeValitsin; // leevi 5 vaihe kayttajat
    
    

   
   

    @FXML private Pane muokkaussivuNext;
    
    @FXML private Label labelValittu;
    
    @FXML private RadioButton rbHuone;

    @FXML private RadioButton rbKayttaja;

    @FXML private RadioButton rbTehtava;
    
    @FXML private ToggleGroup kohdeGroup;
    
    private String id;
    
    @FXML private Button cancelNext;

    @FXML private Button lisaaKayttoon;

    @FXML private TextField nimiText;

    @FXML private Button okTallenna;
    

    @FXML private Button poistaKaytto;

    @FXML void handleCancelNext() {
        ModalController.closeStage(muokkaussivuNext);
    }

    @FXML void handleLisaaKayttoon() {
        //todo
    }

    @FXML void handlePoistaKaytosta() {
        //todo
    }

    @FXML void handleTallenna() {
        Dialogs.showMessageDialog("Tässä kohtaa tallenetaan suoritus(ei osata vielä)");
        ModalController.closeStage(muokkaussivuNext);
    }

    @FXML void nimiReleased() {
        //todo
    }
    

    @FXML private Button lisaaButton;

    @FXML private Button muokkaaButton;

    @FXML private Button poista;

    @FXML void handleLisaa() {
        lisaa();
    }

    @FXML void handleNextMuokkaa() {
        kohdeMuokkaus();
    }

    @FXML
    void handlePoista() {
        poista();
    }
    



    
    private void lisaa() {
        if (id.equals("Käyttäjä")) uusiKayttaja();
        else
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkausnext.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();
            
//            kikkuna = (KayttajaController)fxmlLoader.getController();
//            kikkuna.setrekisteri(rekisteri);
//            kikkuna.setValitsin(kohdeValitsin);
            
            huoneTehtava = (muokkaaNextController)fxmlLoader.getController();
            huoneTehtava.setRekisteri(rekisteri, id);
            huoneTehtava.setValitsin(kohdeValitsin);

            } catch (Exception e) {
                   System.err.println(e.getMessage()); 
             
                }
        

    }
    
    private void poista() {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("poistoikkunaView.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();

            } catch (Exception e) {
                   System.err.println(e.getMessage()); 
             
                }
    }
          
    /**
     * @param location paikka
     * @param resources resurssi
     */
    @Override
    public void initialize(URL location, ResourceBundle resources) {
        kohdeGroup.selectedToggleProperty().addListener( (e) -> nayta());
        labelValittu.setText("");
    }
    
    private void nayta() {
        RadioButton rb = (RadioButton)kohdeGroup.getSelectedToggle();
        if ( rb == null ) return;
        labelValittu.setText("Valittu: " + rb.getText());
        id = rb.getText();
        
        if(id.equals("Käyttäjä")) haeKayttajat();
        if(id.equals("Huone")) haeHuoneet();
        else {
            haeTehtavat();
        }
    }
    
 
    private void haeTehtavat() {
        kohdeValitsin.clear();
        
        for(int i = 0; i < rekisteri.tehtavatlkm(); i++)
        {
            Tehtava lisattava = rekisteri.getTehtava(i);
            kohdeValitsin.add(lisattava.getTehtavaNimi(), lisattava);
        }
        
    }

    private void haeHuoneet() {
        kohdeValitsin.clear();
        for(int i = 0; i < rekisteri.huoneetlkm(); i++)
        {
             Huone lisattava = rekisteri.getHuone(i);
             
            kohdeValitsin.add(lisattava.getNimi(), lisattava);
        }
        
    }

    private void haeKayttajat() {
        kohdeValitsin.clear();
        for(int i = 0; i < rekisteri.kayttajienLkm(); i++)
        {
            Kayttaja lisattava = rekisteri.haeKayttaja(i);
            kohdeValitsin.add(lisattava.getNimi(), lisattava);
        }
        
    }

    private void kohdeMuokkaus() { // ei toimi vielä oikein
         if (id.equals("Käyttäjä")) kayttajaMuokkaus();
         else {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkausnext.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();

            } catch (Exception e) {
                   System.err.println(e.getMessage()); 
             
                }
             
                } 
    }
    private void kayttajaMuokkaus() {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkauskayttaja.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();

            } catch (Exception e) {
                   System.err.println(e.getMessage());
            }
    }
        
    
    
    // leevi 5 vaihe 
    private void uusiKayttaja() {

        
        
      // todo lisää niin että ottaa nimen parametrinä 
        
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkauskayttaja.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();
            
            /// test
            kikkuna = (KayttajaController)fxmlLoader.getController();
            kikkuna.setrekisteri(rekisteri);
            kikkuna.setValitsin(kohdeValitsin);
           
 

            } catch (Exception e) {
                   System.err.println(e.getMessage());     
            }    
        
    }
    
    

    

    
    //// testi
    /**
     * @param rekisteri rekisteri
     * 
     */
    public void setrekisteri(KotityoRekisteri rekisteri) {
        this.rekisteri = rekisteri;
    }


}
